//-- copyright
// Nepenthes is a free and open project management software.
// Copyright (C) 2024 The Nirvati developers
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License version 3.
//
// Nepenthes is a fork of OpenProject. The copyright follows:
//
// Copyright (C) 2012-2024 the OpenProject GmbH
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License version 3.
//
// OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
// Copyright (C) 2006-2013 Jean-Philippe Lang
// Copyright (C) 2010-2013 the ChiliProject Team
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// See COPYRIGHT and LICENSE files for more details.
//++

.attributes-key-value
  display: flex
  // flex-wrap: wrap
  font-size: 0.875rem
  margin-bottom: 0.1875rem
  line-height: 1.5em

  &--key
    @extend .form--label
    display: flex
    flex-basis: 140px
    flex-grow: 1
    padding: 0.375rem 0
    font-weight: var(--base-text-weight-bold)
    overflow-wrap: break-word
    hyphens: auto

    @media screen and (min-width: $breakpoint-md)
      flex-basis: 200px

    @media screen and (min-width: $breakpoint-lg)
      flex-basis: 240px

    > wp-replacement-label
      padding-right: $spot-spacing-0_5
      flex: 1 1 auto
      max-width: calc(100% - 1rem)
      word-wrap: break-word

    > attribute-help-text
      flex: 100 0 auto

  &--value-container
    display: flex
    flex-basis: 260px
    flex-grow: 1000000
    flex-shrink: 1
    margin-bottom: 0.1875rem
    padding: 0.375rem 0
    height: 100%
    overflow: hidden

    p
      font-size: $form-label-fontsize
      word-wrap: break-word

    &.not-editable
      padding: 6px

  &--value
    @include grid-visible-overflow
    word-wrap: anywhere

// Alternative implementation to the one above.
// It's main advantage is that it can act on the whole of the key/value-pairs.
// It can e.g. determine the width of the widest label and by that align all key value pairs equally.

.attributes-map
  display: grid
  grid-template-columns: 1fr 2fr
  grid-auto-rows: auto
  grid-gap: 1rem

  &.-minimal-keys
    grid-template-columns: max-content 2fr

.attributes-map--key
  @include text-shortener
  font-weight: var(--base-text-weight-bold)
  line-height: 27px

  &.-required:after
    @extend %required-star

  .attributes-map.-minimal-keys &
    max-width: 200px

.attributes-map--value
  zoom: 1
  @include text-shortener(false)

  &_overflow
    overflow: visible
